.\" Copyright (c) 1980, 1991, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)setreuid.2	8.2 (Berkeley) 4/16/94
.\"
.Dd April 16, 1994
.Dt SETREUID 2
.Os BSD 4
.Sh NAME
.Nm setreuid
.Nd set real and effective user ID's
.Sh SYNOPSIS
.Fd #include <unistd.h>
.Ft int
.Fn setreuid "uid_t ruid" "uid_t euid"
.Sh DESCRIPTION
The real and effective user IDs of the
current process are set according to the arguments.
If
.Fa ruid
or 
.Fa euid
is -1, the current uid is filled in by the system.
Unprivileged users may change the real user
ID to the effective user ID and vice-versa; only the super-user may
make other changes.
.Pp
The
.Fn setreuid
function has been used to swap the real and effective user IDs
in set-user-ID programs to temporarily relinquish the set-user-ID value.
This purpose is now better served by the use of the
.Fn seteuid
function (see
.Xr setuid 2 ) .
.Pp
When setting the real and effective user IDs to the same value,
the standard
.Fn setuid
function is preferred.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.  Otherwise,
a value of -1 is returned and
.Va errno
is set to indicate the error.
.Sh ERRORS
.Bl -tag -width [EPERM]
.It Bq Er EPERM
The current process is not the super-user and a change
other than changing the effective user-id to the real user-id
was specified.
.El
.Sh SEE ALSO
.Xr getuid 2 ,
.Xr issetugid 2 ,
.Xr seteuid 2 ,
.Xr setuid 2
.Sh HISTORY
The
.Fn setreuid
system call appeared in
.Bx 4.2 .
